#!/usr/local/bin/perl

#
# This program requires Tk module.
# So, this is script for Perl/Tk.
#
use Tk;

sub showlog {
    local($fw, $p, $h) = @_;
    local($f);
    local($l);
    local($i);
    local($w, $wsv, $wsh);
    local($pos);

#   print STDERR "widget $fw\n";
#   print STDERR "position $p\n";

    if(defined $Lfname{$fw}) {
        $f = $Lfname{$fw};
    }
#   print "filename for $fw is '$f'\n";

    $w = $Ltext{$fw};

    open(F, "<$f") || return;

    if($Lmode{$fw}==1) {
        $Lsize{$fw} = (stat F)[7];
        printf "name '%s', %ld bytes\n", $f, $Lsize{$fw};
    }

    if($p<0) {
        $p = $Lsize{$fw} - 1024;
    }

    $Lpos{$fw} = $p;

    $w->delete("1.0", "end");

#   printf "height %d , %d\n", $w->height(), $w->reqheight();

    seek(F, $p, 0);
    if($h<0) {
        $h = 72;
    }

    # skip rest of line at current position
    if($p!=0) {
        $l = <F>;
    }

    for($i=0;$i<$h;$i++) {
        $l = <F>;
#       print "line $i:<$l>\n";
#       $w->insert('end', "line $i:");
        if($l =~ /^\|/) {
            $w->insert('end', $l, 'info');
        }
        elsif($l =~ /^:/) {
            $w->insert('end', $l, 'mon');
        }
        elsif($l =~ /\bself\b/) {
            $w->insert('end', $l, 'ssess');
        }
        else {
            $w->insert('end', $l, 'csess');
        }
    }

    $pos = tell F;

    close(F);

    $w = $Lvs{$fw};
    $w->set($Lpos{$fw}/$Lsize{$fw}, ($pos)/$Lsize{$fw});

}

sub sc {
    local($fw, $dir, $val)  = @_;
    local($pos);

    $pos = $Lpos{$fw};

#   print "sc $fw $dir $val\n";

    if($dir eq "moveto") {
        $pos = int($Lsize{$fw} * $val);
    }
    elsif($dir eq "scroll") {
        if($val== -1) {
            $pos -= 1024;
        }
        elsif($val== 1) {
            $pos += 1024;
        }
    }
    else {
        if($dir== -1) {
            $pos -= 1024;
            if($pos<0) {
                $pos = 0;
            }
        }
        elsif($dir== 1) {
            $pos += 1024;
        }
    }

    if($pos<0) {
        $pos = 0;
    }
    if($pos>$Lsize{$fw}) {
        $pos = $Lsize{$fw};
    }

#   print "position $Lpos{$fw} -> $pos\n";

    &showlog($fw, $pos, -1);
}


sub bindlogfile {
    local($fw, $f, $h) = @_;
    local($l);
    local($i);
    local($w, $wsv, $wsh);

    my $hs = $fw->Scrollbar(-orient => "horizontal");
    my $vs = $fw->Scrollbar();
    my $t = $fw->Text(-wrap => "none",
					-width => "200",
					-height => "30",
                    -xscrollcommand => ['set' => $hs] );

    $hs->pack(-side =>"bottom", -fill => "x");
    $vs->pack(-side =>"left",   -fill => "y");
    $t->pack(-side  =>"top", -fill => "both", -expand => "0");

    $hs->configure(-command => [xview, $t]);
    $vs->configure(-command => [\&sc, $fw]);

#   print STDERR "widget $fw\n";
#   print STDERR "filename $f\n";
#   print STDERR "position $p\n";

    $Lfname{$fw} = $f;
    $Lpos{$fw} = $p;
    $Lmode{$fw} = 0;
    $Ltext{$fw} = $t;
    $Lvs{$fw} = $vs;

    if(-f $f) {
        open(F, "<$f");
        $Lsize{$fw} = (stat F)[7];
        close(F);
        printf "name '%s', %ld bytes\n", $f, $Lsize{$fw};
    }
    else {
        $Lsize{$fw} = -1;
    }

    $t->tagConfigure('info', -foreground => "red");
    $t->tagConfigure('mon',  -foreground => "blue");
    $t->tagConfigure('csess', -foreground => "black");
    $t->tagConfigure('ssess', -foreground => "darkgreen");

    &showlog($fw, 0, $h);
}

if(0) {
    print <<EOM;
usage: $0 file
EOM
}

if($ARGV[0]) {
    $logfilename = $ARGV[0];
}
else {
    $logfilename = "kotetu.log";
}

if(! -f $logfilename) {
    print <<EOM;
Specified log-file '$logfilename' is not found.
EOM
    exit 0;
}

sub tobetop{
    local($fw) = @_;
    local($f);

    $f = $Lfname{$fw};

    &showlog($fw, 0, -1);
}
sub refresh {
    local($fw) = @_;
    local($f);

    $f = $Lfname{$fw};

    open(F, "<$f") || return;
    $Lsize{$fw} = (stat F)[7];
    printf "name '%s', %ld bytes\n", $f, $Lsize{$fw};
    close F;

    &showlog($fw, -1, -1);
}


sub solve_time_range {
    local($fw, $f) = @_;
    local($t);
    local($c);
    local($tmin, $tmax);
    local(@fs);
    local($len);
    local($toplinemargin, $bottombytemargin);

    print "solve_time_rage: filename '$f'\n";
    $len = (stat($f))[7];
    print "\tsize $len bytes\n";

    $tmin = time + 86400;
    $tmax = 0;
    $toplinemargin = 100;
    $bottombytemargin = 256*1024;

    open(F, "< $f");

    $c=0;
    while(<F>) {
        if(/^\|/) {
            next;
        }
        if(/^:/) {
            next;
        }
        @fs = split;

# print "a $fs[6] $fs[16] $fs[23]\n";
        if($fs[6] ne ':' || $fs[16] ne ':' || $fs[23] ne ':') {
            next;
        }

        $c++;

        $t = $fs[3];

        if($t<$tmin) {
            $tmin = $t;
        }
        if($t>$tmax) {
            $tmax = $t;
        }

        ### break after reading of several lines
        if($c>$toplinemargin) {
            last;
        }
    }

    if($len>$bottombytemargin) {
#       print "seek $bottombytemargin before end of file\n";
        seek F, -$bottombytemargin, 2;
    }
    else {
#       print "seek top of file\n";
        seek F, 0, 0;
    }

    $c=0;
    while(<F>) {
        if(/^\|/) {
            next;
        }
        if(/^:/) {
            next;
        }
        @fs = split;

#print "b $fs[6] $fs[16] $fs[23]\n";
        if($fs[6] ne ':' || $fs[16] ne ':' || $fs[23] ne ':') {
            next;
        }

        $c++;

        $t = $fs[3];

        if($t<$tmin) {
            $tmin = $t;
        }
        if($t>$tmax) {
            $tmax = $t;
        }
    }

    close(F);

    printf "t [%.3f, %.3f] diff %d (%d days %d hours)\n",
        $tmin, $tmax, $tmax-$tmin,
        ($tmax-$tmin)/86400, (($tmax-$tmin)%86400)/3600;

    $Ltmin{$fw} = $tmin;
    $Ltmax{$fw} = $tmax;
}

sub solve_time_pos {
    local($fw, $f, $xt) = @_;
	local($left, $center, $right);
	local($t, $lastcenter);
	local($line);


	$left = 0;
    $right = (stat($f))[7];
	$center = int(($left+$right)/2);
	$lastcenter = -1;

	open(F, "<$f") || return -1;

	while(1) {
#		print "0 $left - $center - $right\n";

		seek(F, $center, 0);
		$line = <F>;
		$t = -1;
		for(;$t<=0;) {
			$line = <F>;
#			print "  line <$line>\n";
			if($line =~ /(^\|)|(^:)/) {
				next;
			}
			$t = int((split /\s+/, $line)[2]);
#			print "  t? $t\n";
		}

#		print "  center pos. $center, t $t v.s. $xt\n";

		if($t>$xt-600 && $t<$xt+600) {
			last;
		}

		if($t<$xt) {
			$left = $center;
		}
		elsif($t>$xt) {
			$right = $center;
		}

		$center = int(($left+$right)/2);
#		print "  1 $left - $center - $right\n";

		if($center==$lastcenter) {
			last;
		}
		if($center<=$left) {
			last;
		}
		if($center>=$right) {
			last;
		}

		$lastcenter = $center;
	}

	close(F);

	return $center;
}

sub draw_range_hitratio {
    local($w, $f) = @_;
    local($c, $t, $lastt, $x, $y);
    local($gx, $gy);
    local($chit, $cmiss);
    local($cclient, $cself);
    local($zx, $zy);
	local($bt);

    local($begin, $end, $u);
    $begin  = $Lbegin{$w};
    $end    = $Lend{$w};
    $u      = $Lunit{$w};
    $xtic   = $Lttic{$w};

    print "draw_range_hitratio: filename '$f', range $begin .. $end, unit $u\n";

    if($u eq '') {
        $u = 30;
    }
    elsif($u < 30) {
        $u = 30;
    }

	
	$bt = int($begin/$u)*$u;

	local($begin_pos, $end_pos);
	$begin_pos = &solve_time_pos($w, $f, $bt);
	$end_pos = &solve_time_pos($w, $f, $end);
	print "pos [$begin_pos..$end_pos], t [$bt..$end])\n";
	

    open(F, "< $f");

    $c = 0;
    $chit = 0;
    $cmiss = 0;
    $cclient = 0;
    $cself = 0;

    $tmin = time + 86400;
    $tmax = 0;

#    $lastt = $begin;
    $lastt = $bt;

	seek F, $begin_pos, 0;

    while(<F>) {
        $c++;
        if(/^\|/) {
            next;
        }
        if(/^:/) {
            next;
        }
        @fs = split;

#print "$fs[6] $fs[16] $fs[23]\n";
        if($fs[6] ne ':' || $fs[16] ne ':' || $fs[23] ne ':') {
            next;
        }

        $t = $fs[2];

        if($t<$tmin) {
            $tmin = $t;
        }
        if($t>$tmax) {
            $tmax = $t;
        }

        if($fs[7] eq 'self') {
            $cself++;
        }
        else {
            $cclient++;
            if($fs[17] eq 'HIT') {
                $chit++;
            }
            if($fs[17] eq 'MISS') {
                $cmiss++;
            }
        }
        if($chit+$cmiss>0) {
            $hratio = 100.0*$chit / ($chit+$cmiss);
        }
        else {
            $hratio = -1;
        }
#       printf "hit %9d miss %9d -> ratio %7.2f\n", $chit, $cmiss, $hratio;

if(0) {
        if($cclient%$u==0) {
#           printf("\tt %d (%d) h %7.2f\n", $t, $tmin, $hratio);
            $hlist{$t} = $hratio;
        }
}

#printf "    t %d diff %d\n", $t, $t-$lastt;
        if(($t%$u)==0) {
#            printf("\tt %d -> %d  h %7.2f\n", $t, int($t/$u)*$u, $hratio);
            $hlist{int($t/$u)*$u} = $hratio;
            $lastt = $t;
        }

		if($t>$end) {
			last;
		}

    }
    close(F);

    print "read $c lines\n";
    printf "t [%.3f, %.3f] diff %d (%d days %d hours)\n",
        $tmin, $tmax, $tmax-$tmin,
        ($tmax-$tmin)/86400, (($tmax-$tmin)%86400)/3600;
    printf "range [%.3f, %.3f] diff %d (%d days %d hours)\n",
        $begin, $end, $end-$begin,
        ($end-$begin)/86400, (($end-$begin)%86400)/3600;
    print "sessions client=$cclient self=$cself\n";
    print "  hit $chit, miss $cmiss, ratio $hratio\n";
    @tlist = sort {$a<=>$b} keys %hlist;

    $ww = $end-$begin;
#   $xtic = $u*10;
    $ws = 400;
    $hs = $ws / $ww;

    print "xtic $xtic, ws $ws, hs $hs\n";
	print "u $u, xtic $xtic, skip ".($u*$xtic)."\n";

    $zx = 50;
    $zy = 150;
    $vs = 1;

#	$bt = int($begin/$u)*$u;

    # clear canvas
    $w->delete("all");

	###
    ### axies
	###
    for($y=0;$y<=100;$y+=20) {
        $gy = $y*$vs;
#       print "y gy = $y $gy\n";
        $w->createLine($zx, $zy-$gy, $zx+$ws, $zy-$gy, -fill => "gray80");
    }
    for($x=0;$x<=$ww;$x+=($u*$xtic)) {
        $gx = $x*$hs;
#       print "x gx = $x $gx\n";
        $w->createLine($zx+$gx, $zy, $zx+$gx, $zy-100*$vs, -fill => "gray80");
    }
    $w->createLine($zx, $zy, $zx+$ws+$zx/2, $zy, -arrow => "last");
    $w->createLine($zx, $zy, $zx, $zy-100*$vs-$zx/2, -arrow => "last");

    for($y=0;$y<=100;$y+=20) {
        $gy = $y*$vs;
#       print "y gy = $y $gy\n";
        $w->createText($zx-4, $zy-$gy,
			-text => "$y", -anchor => "e");
    }

	local(@p, $slong, $s1, $s2);

    for($t=$bt; $t<=$end; $t+=($u*$xtic)) {
		$gx  = ($t - $bt) * $hs;
		@p = localtime($t);
		$p[5] += 1900;
		$p[4] += 1;

		$slong = sprintf "%4d/%02d/%02d %2d:%02d:%02d",
				$p[5], $p[4], $p[3], $p[2], $p[1], $p[0];
		if($u*$xtic > 3600) {
			$s1 = sprintf "%2d/%02d", $p[4], $p[3];
			$s2 = sprintf "%02dh", $p[2];
		}
		elsif($u*$xtic == 3600) {
			$s1 = sprintf "%2dh", $p[2];
		}
		else {
			$s1 = sprintf "%2d:%02d",
					$p[2], $p[1];
		}
#        print "t $t, gx $gx // $slong // '$s1' '$s2'\n";

		if($s1 ne '') {
			$w->createText($zx+$gx, $zy+4,
				-text => "$s1", -anchor => "n");
		}
		if($s2 ne '') {
			$w->createText($zx+$gx, $zy+14,
				-text => "$s2", -anchor => "n");
		}
    }

    $lx = 0;
    $ly = 0;
	for($t=$bt; $t<=$end; $t+=$u) {
#      	printf("\tt %7d\t", $t);
		$x = ($t - $bt) * $hs;

      	if(defined $hlist{$t}) {
        	$y = $hlist{$t} * $vs;
      	}
		else {
			$y = 0 * $vs;
		}

#        printf("r x,y %12d,%7.2f\n", $x, $y);

		$w->createLine($zx+$lx, $zy-$ly, $zx+$x, $zy-$y, -fill => "red");
		$lx = $x;
		$ly = $y;
    }

    undef %hlist;
    undef @tlist;

}

sub trans_h {
	local($w, $vw, $n, $pw) = @_;
	local($t, $s, @p);
	
#	print "self '$w', widget '$vw', name '$n', parent '$pw'\n";

	$t = $$n{$pw};
#	print "  -> '$t'\n";

	@p = localtime($t);
	$p[5] += 1900;
	$p[4] += 1;
	$s = sprintf "%4d/%02d/%02d %02d:%02d:%02d",
			$p[5], $p[4], $p[3], $p[2], $p[1], $p[0];
	
	$vw->configure(-text => $s);
}

sub updatecmdwin {
	local($w, $a, $b, $f) = @_;
	
	print "udpatecmdwin $w $a $b $f\n";

	&solve_time_range($w, $f);

	$a->configure(-from => $Ltmin{$w}, -to => $Ltmax{$w});
	$b->configure(-from => $Ltmin{$w}, -to => $Ltmax{$w});
}

sub mkgraphcmdwin{
    local($root, $f) = @_;
    local($gw);
    local($gf);
    local($cls);
    local($scv, $cv);
    local($Bclose, $Bupdate, $Bdraw);
    local($tsel1, $tsel2);
	local($tsl1, $tsl2);
    local($tsc1, $tsc2);
	local($tunitw, $tticw);

    $gw = $root->Toplevel();
    $gw->configure(-title => "Graph $f");

    $gf = $gw->Frame()->pack(-fill =>"both", -expand => "1");

    $cls = $gf->Frame(-relief => "groove", -borderwidth => "2")
            ->pack(-side => "top",
                -fill => "x", -expand => "0", -pady => "3", -pady => "2");

	$tsel = $gf->Frame()
            ->pack(-anchor => "w", -fill =>"x", -expand => "0");

    $scv = $gf->Scrolled("Canvas", -background => "white",
                -width => "50", -height => "50")
            ->pack(-side => "top", -fill => "both", -expand => "1");
    $cv = $scv->Subwidget("canvas");
    $cv->configure(-width => "500", -height => "200");

    $Bclose = $cls->Button(-text => "Close",
			-background => "lightcyan", -relief => "ridge",
            -command => ['destroy',$gw] )
            ->pack(-side => "left", -padx=>"4", -pady=>"4");
    $Bupdate = $cls->Button(-text => "Update")
            ->pack(-side => "left", -padx=>"4", -pady=>"4");
    $Bdraw = $cls->Menubutton(-text => "Graph")
            ->pack(-side => "left", -padx=>"4", -pady=>"4");


    local($tmin, $tmax);
    solve_time_range($w,$f);
    $tmin = $Ltmin{$w};
    $tmax = $Ltmax{$w};
    print "tmin $tmin tmax $tmax\n";

	$tsel->Label(-text => "time begin", -width => "12", -justify =>"left")
		->grid(
			$tsv1 = $tsel->Label(-width => 20),
			$tsc1 = $tsel->Scale(-orient => "horizontal",
				-length => 300,
				-from => $tmin, -to => $tmax, -resolution => 60,
				-variable => \$Lbegin{$cv})
		);
	$tsc1->bind("<ButtonRelease-1>",[\&trans_h, $tsv1, "Lbegin", $cv] );
	$tsc1->bind("<B1-Motion>",		[\&trans_h, $tsv1, "Lbegin", $cv] );

	$tsel->Label(-text => "time end", -width => "12", -justify =>"left")
     	->grid(
			$tsv2 = $tsel->Label(-width => 20),
			$tsc2 = $tsel->Scale(-orient => "horizontal",
				-length => 300,
				-from => $tmin, -to => $tmax, -resolution => 60,
				-variable => \$Lend{$cv})
		);
	$tsc2->bind("<ButtonRelease-1>",[\&trans_h, $tsv2, "Lend", $cv] );
	$tsc2->bind("<B1-Motion>", 		[\&trans_h, $tsv2, "Lend", $cv] );

    $Lbegin{$cv} = $tmax - 86400;
    $Lend{$cv} = $tmax;

	&trans_h($tsc1, $tsv1, "Lbegin", $cv);
	&trans_h($tsv2, $tsv2, "Lend", $cv);

	$Bupdate->configure( -command => [\&updatecmdwin,$gw,$tsc1,$tsc2,$f] );

    local($n, $v);

    local(%unitlist) = (
            "30sec",    30,
            "1min",     60,
            "10min",    600,
            "30min",    1800,
            "1hour",    3600,
#           "2hour",    3600*2,
#           "3hour",    3600*3,
#           "4hour",    3600*4,
#           "6hour",    3600*6,
            "12hour",   3600*8,
            "1day",     86400,
#           "1week",    86400*7,
        );

	$tsel->Label(-text => "unit", -width => "12", -justify =>"left")
 		->grid($tunitw = $tsel->Frame(), "-");

    foreach $n (sort {$unitlist{$a}<=>$unitlist{$b}} keys %unitlist) {
        $tunitw->Radiobutton(
            -text =>$n, -value => $unitlist{$n}, -variable => \$Lunit{$cv} )
            ->pack(-side => "left", -padx=>"4", -pady =>"4");
    }


    local(%ticlist) = (
            "1",     	1,
            "2",     	2,
            "5",     	5,
            "6",     	6,
            "10",     	10,
            "12",     	12,
            "20",     	20,
            "30",     	30,
            "50",     	50,
            "60",     	60,
        );

    $tsel->Label(-text => "tic", -width => "12", -justify =>"left")
        	->grid($tticw = $tsel->Frame(), "-");

    foreach $n (sort {$ticlist{$a}<=>$ticlist{$b}} keys %ticlist) {
        $tticw->Radiobutton(
            -text =>$n, -value => $ticlist{$n}, -variable => \$Lttic{$cv} )
            ->pack(-side => "left", -padx=>"4", -pady =>"4");
    }


    $Lunit{$cv} = 3600;
    $Lttic{$cv} = 6;

    $Bdraw->command(-label => "Hit ratio",
      -command => [\&draw_range_hitratio,$cv,$f] );
}

print "booting... \n";

my $root = MainWindow->new;
$root->title("Kotetu Log Viewer");

my $rf = $root->Frame()->pack(-fill => "both", -expand => "1", -pady => "2");
my $cl = $rf->Frame(-relief => "groove", -borderwidth => "2")
            ->pack(-side => "top", -anchor => "n",
                -fill => "x", -expand => "0", -pady => "3", -pady => "2");
my $q = $cl->Button(-text => "Quit",
			-background => "lightcyan", -relief => "ridge",
 			-command => sub {exit})
            ->pack(-side => "left", -padx => "3", -pady => "3");
my $h = $cl->Button(-text => "Help")
            ->pack(-side => "right", -padx => "3", -pady => "3");

my $f = $rf->Frame(-borderwidth => "2",
            -label => "raw log")
            ->pack(-fill => "both", -expand => "0", -padx => "2", -pady => "2");

&bindlogfile($f, $logfilename, -1);

my $r = $cl->Button(-text => "Head", -command => [\&tobetop, $f])
            ->pack(-side => "left", -padx => "3", -pady => "3");
my $r = $cl->Button(-text => "Tail", -command => [\&refresh, $f])
            ->pack(-side => "left", -padx => "3", -pady => "3");
my $g = $cl->Button(-text => "Graph",
            -command => [\&mkgraphcmdwin, $root, $logfilename])
            ->pack(-side => "left", -padx => "3", -pady => "3");

MainLoop;

